package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadCH4ValueCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadCH4ValueTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadCH4ValueTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取甲烷参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadCH4ValueCommand ch4Cmd = (ReadCH4ValueCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(ch4Cmd.getCommandType());
		cmd.setDest(ch4Cmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { ch4Cmd.getMemoryArea() }));
		cmd.setStart_mem_word(ch4Cmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(ch4Cmd.getStartAddress().substring(4));
		cmd.setCount_word(ch4Cmd.getCountWord());
		cmd.setCount_bit(ch4Cmd.getCountBit());
		cmd.setCount_sensor(ch4Cmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
